# coding: utf-8

"""
    Flywheel

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)  # noqa: E501

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from flywheel.api_client import ApiClient
import flywheel.models

# NOTE: This file is auto generated by the swagger code generator program.
# Do not edit the class manually.

class ChangeLogApi(object):
    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_change_log(self, container_type, container_id, **kwargs):  # noqa: E501
        """Get Change Log

        This method makes a synchronous HTTP request by default.

        :param ChangeLogContainerType container_type: (required)
        :param str container_id: (required)
        :param int version: Optional version if retrieving logs for file
        :param bool async_: Perform the request asynchronously
        :return: ChangeLogDocument
        """
        ignore_simplified_return_value = kwargs.pop('_ignore_simplified_return_value', False)
        kwargs['_return_http_data_only'] = True

        if kwargs.get('async_'):
            return self.get_change_log_with_http_info(container_type, container_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_change_log_with_http_info(container_type, container_id, **kwargs)  # noqa: E501
            if (
                data
                and hasattr(data, 'return_value')
                and not ignore_simplified_return_value
            ):
                return data.return_value()
            return data


    def get_change_log_with_http_info(self, container_type, container_id, **kwargs):  # noqa: E501
        """Get Change Log

        This method makes a synchronous HTTP request by default.

        :param ChangeLogContainerType container_type: (required)
        :param str container_id: (required)
        :param int version: Optional version if retrieving logs for file
        :param bool async_: Perform the request asynchronously
        :return: ChangeLogDocument
        """

        all_params = ['container_type','container_id','version',]  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('_request_out')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_change_log" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'container_type' is set
        if ('container_type' not in params or
                params['container_type'] is None):
            raise ValueError("Missing the required parameter `container_type` when calling `get_change_log`")  # noqa: E501
        # verify the required parameter 'container_id' is set
        if ('container_id' not in params or
                params['container_id'] is None):
            raise ValueError("Missing the required parameter `container_id` when calling `get_change_log`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'container_type' in params:
            path_params['container_type'] = params['container_type']  # noqa: E501
        if 'container_id' in params:
            path_params['container_id'] = params['container_id']  # noqa: E501

        query_params = []
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ApiKey']  # noqa: E501

        return self.api_client.call_api(
            '/changes/{container_type}/{container_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ChangeLogDocument',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            _request_out=params.get('_request_out'),
            collection_formats=collection_formats)

    def get_field_change_log(self, container_type, container_id, field, **kwargs):  # noqa: E501
        """Get change logs by specific field, in reverse chronological order

        This method makes a synchronous HTTP request by default.

        :param ChangeLogContainerType container_type: (required)
        :param str container_id: (required)
        :param str field: (required)
        :param int version: Optional version if retrieving logs for file
        :param bool async_: Perform the request asynchronously
        :return: FieldChangeLogDocument
        """
        ignore_simplified_return_value = kwargs.pop('_ignore_simplified_return_value', False)
        kwargs['_return_http_data_only'] = True

        if kwargs.get('async_'):
            return self.get_field_change_log_with_http_info(container_type, container_id, field, **kwargs)  # noqa: E501
        else:
            (data) = self.get_field_change_log_with_http_info(container_type, container_id, field, **kwargs)  # noqa: E501
            if (
                data
                and hasattr(data, 'return_value')
                and not ignore_simplified_return_value
            ):
                return data.return_value()
            return data


    def get_field_change_log_with_http_info(self, container_type, container_id, field, **kwargs):  # noqa: E501
        """Get change logs by specific field, in reverse chronological order

        This method makes a synchronous HTTP request by default.

        :param ChangeLogContainerType container_type: (required)
        :param str container_id: (required)
        :param str field: (required)
        :param int version: Optional version if retrieving logs for file
        :param bool async_: Perform the request asynchronously
        :return: FieldChangeLogDocument
        """

        all_params = ['container_type','container_id','field','version',]  # noqa: E501
        all_params.append('async_')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')
        all_params.append('_request_out')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_field_change_log" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'container_type' is set
        if ('container_type' not in params or
                params['container_type'] is None):
            raise ValueError("Missing the required parameter `container_type` when calling `get_field_change_log`")  # noqa: E501
        # verify the required parameter 'container_id' is set
        if ('container_id' not in params or
                params['container_id'] is None):
            raise ValueError("Missing the required parameter `container_id` when calling `get_field_change_log`")  # noqa: E501
        # verify the required parameter 'field' is set
        if ('field' not in params or
                params['field'] is None):
            raise ValueError("Missing the required parameter `field` when calling `get_field_change_log`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'container_type' in params:
            path_params['container_type'] = params['container_type']  # noqa: E501
        if 'container_id' in params:
            path_params['container_id'] = params['container_id']  # noqa: E501
        if 'field' in params:
            path_params['field'] = params['field']  # noqa: E501

        query_params = []
        if 'version' in params:
            query_params.append(('version', params['version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ApiKey']  # noqa: E501

        return self.api_client.call_api(
            '/changes/{container_type}/{container_id}/fields/{field}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FieldChangeLogDocument',  # noqa: E501
            auth_settings=auth_settings,
            async_=params.get('async_'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            _request_out=params.get('_request_out'),
            collection_formats=collection_formats)
